build:front:
  stage: build
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - cd demonstrator/service_front
  script:
    - env
    - if [ "${CI_COMMIT_REF_NAME}" == "master" ]; then SUBDOMAIN="staging"; else SUBDOMAIN="${CI_COMMIT_REF_SLUG}"; fi
    - echo "REACT_APP_BASE_URL=https://${SUBDOMAIN}.gaia-x-demonstrator.eu/api/v1" > .env
    - docker build --tag service_front:${CI_COMMIT_SHORT_SHA} .
    - docker tag service_front:${CI_COMMIT_SHORT_SHA} ${CI_REGISTRY_IMAGE}/service_front:${CI_COMMIT_REF_SLUG}-latest
    - docker login --username ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY_IMAGE}
    - docker push ${CI_REGISTRY_IMAGE}/service_front

test:front:
  stage: test
  image: docker:stable
  services:
    - docker:dind
  before_script:
    - cd demonstrator/service_front
  script:
    - docker login --username ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY_IMAGE}
    - docker stop service_front || true
    - docker network inspect testing || docker network create testing
    - docker run --rm -d --name service_front --network testing -p 8080:80 ${CI_REGISTRY_IMAGE}/service_front:${CI_COMMIT_REF_SLUG}-latest
    - docker logs --follow service_front &
    - wget -O - http://localhost:8080/
    - kill $(jobs -p)
  after_script:
    - docker stop service_front
  only:
    changes:
      - demonstrator/service_front/**/*


deploy:front:staging:
  extends: .ci_deploy_config_master
  script:
    - cd demonstrator/service_front
    - ./generate_kube_config.sh | kubectl apply -f -
    - kubectl delete pod -l app=service-front # force to fetch new image

deploy:front:branch:
  extends:
    - deploy:front:staging
    - .ci_deploy_config_branch
